    Program f07wxfe

!     F07WXF Example Program Text

!     Mark 24 Release. NAG Copyright 2012.

!     .. Use Statements ..
      Use nag_library, Only: nag_wp, x04dbf, ztftri, ztfttr
!     .. Implicit None Statement ..
      Implicit None
!     .. Parameters ..
      Integer, Parameter               :: nin = 5, nout = 6
!     .. Local Scalars ..
      Integer                          :: ifail, info, ldf, lena, n
      Character (1)                    :: diag, transr, uplo
!     .. Local Arrays ..
      Complex (Kind=nag_wp), Allocatable :: a(:), f(:,:)
      Character (1)                    :: clabs(1), rlabs(1)
!     .. Executable Statements ..
      Write (nout,*) 'F07WXF Example Program Results'
!     Skip heading in data file
      Read (nin,*)
      Read (nin,*) n, uplo, transr, diag

      lena = n*(n+1)/2
      ldf = n
      Allocate (a(1:lena),f(ldf,n))

!     Read A from data file
      Read (nin,*) a(1:lena)

!     Compute inverse of A
!     The NAG name equivalent of ztftri is f07wxf
      Call ztftri(transr,uplo,diag,n,a,info)

      Write (nout,*)
      Flush (nout)
      If (info==0) Then

!       Convert and print inverse
!       The NAG name equivalent of ztfttr is f01vhf
        Call ztfttr(transr,uplo,n,a,f,ldf,info)
        ifail = 0

        Call x04dbf(uplo,'Nonunit',n,n,f,ldf,'Bracketed','F7.4','Inverse', &
          'Integer',rlabs,'Integer',clabs,80,0,ifail)
      Else
        Write (nout,*) 'A is singular'
      End If

    End Program f07wxfe
